function intervalToDate(interval, date) {
	if (!interval) return null;
	var startDate=date;
	if (!startDate) startDate=new Date;
	var match=interval.match(/([-0-9]+) ([a-zA-Z]+)/);
	if (match.length != 3) return null;
	switch (match[2].toLowerCase()) {
		case 'year':
			startDate.setFullYear(startDate.getFullYear()+parseInt(match[1]));
		break;
		case 'month':
			startDate.setMonth(startDate.getMonth()+parseInt(match[1]));
		break;
		case 'day':
			startDate.setDate(startDate.getDate()+parseInt(match[1]));
		break;
	}
	return startDate;
}

function setCookie(name, value, expires, path, domain, secure) {
    document.cookie=name+"="+escape(value)+((expires)?"; expires="+expires.toGMTString():"")+((path)?"; path="+path:"")+((domain)?"; domain="+domain:"")+((secure)?"; secure":"");
}

function getCookie(name) {
    var dc=document.cookie;
    var prefix=name + "=";
    var begin=dc.indexOf("; " + prefix);
    if (begin == -1) {
        begin=dc.indexOf(prefix);
        if (begin != 0) return null;
    }else begin += 2;
    var end = document.cookie.indexOf(";", begin);
    if (end == -1) end = dc.length;
    return unescape(dc.substring(begin + prefix.length, end));
}

function deleteCookie(name, path, domain) {
    if (getCookie(name))
        document.cookie=name+"="+((path)?"; path="+path:"")+((domain)?"; domain="+domain:"")+"; expires=Thu, 01-Jan-70 00:00:01 GMT";
}

function getUserInfo(mid, field) {
	if (!_XMLHttp['getMid']) _XMLHttp['getMid']=new XMLHttp('get_userInfo');
	_XMLHttp['getMid'].setQuery('q[gid]='+_siteGid+(mid?'&q[mid]='+mid:''));
	_XMLHttp['getMid'].setAsync(false);
	_XMLHttp['getMid'].execute();

	var data=_XMLHttp['getMid'].getResponse('USER');
	if (data) {
		if (field) return data[0][field];
		else return data[0];
	}
	return null;
}
